#include <Windows.h>
#include "Splasher.h"

HBITMAP s_hBitmap = NULL;
HDC     s_hDCMemory = NULL;
BITMAP  s_bmpInfo = {0};

LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
static void FreeRes();

int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)
{
	HWND hWnd = NULL;
	int iWidth = 0;
	int iHeight = 0;

	MSG msg;
	WNDCLASS WndClass; 

	Splash_Create(hInstance,_T("splash.bmp"),FALSE,FLAG_DROPSHADOW|FLAG_DRAGGABLE,
		0,
		_T("splash.wav"),FALSE,
		8000);

	Splash_ShowText(_T("Loading main image..."),RGB(255,0,0));
	s_hBitmap = (HBITMAP)LoadImage(NULL, 
		_T("programmer_life.bmp"),
		IMAGE_BITMAP, 
		0, 
		0, 
		LR_DEFAULTSIZE | LR_DEFAULTCOLOR|LR_LOADFROMFILE );
	if( s_hBitmap == NULL )
	{
		Splash_Close(NULL);
		return 0;
	}

	GetObject(s_hBitmap, sizeof(BITMAP), &s_bmpInfo);
	s_hDCMemory = CreateCompatibleDC(NULL);
	if( s_hDCMemory == NULL )
	{
		FreeRes();
		Splash_Close(NULL);
		return 0;
	}
	SelectObject(s_hDCMemory,s_hBitmap);
	
	WndClass.style = 0;
	WndClass.lpfnWndProc = (WNDPROC)WndProc;
	WndClass.cbClsExtra = 0;
	WndClass.cbWndExtra = 0;
	WndClass.hInstance = hInstance;
	WndClass.hIcon = NULL;
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	WndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);;
	WndClass.lpszMenuName = NULL;
	WndClass.lpszClassName = _T("SplashDemo");
	if ( !RegisterClass(&WndClass) )
	{
		FreeRes();
		Splash_Close(NULL);
		return 0;
	}

	iWidth = GetSystemMetrics(SM_CXSCREEN);
	iHeight = GetSystemMetrics(SM_CYSCREEN);
	hWnd = CreateWindowEx(WS_EX_TOPMOST, _T("SplashDemo"), _T("SplashDemo Window"), WS_POPUP, 0, 0, iWidth, iHeight, NULL, NULL, hInstance, 0);

	Splash_Close(NULL);

	if( !hWnd  )
	{
		FreeRes();
		return 0;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	FreeRes();

	return (int) msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
// 		switch (wmId)
// 		{
// 		default:
// 			return DefWindowProc(hWnd, message, wParam, lParam);
// 		}
		break;
	case WM_LBUTTONDOWN:
		DestroyWindow(hWnd);
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		StretchBlt(hdc, 0, 0, GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN), 
			s_hDCMemory, 0, 0, s_bmpInfo.bmWidth, s_bmpInfo.bmHeight, 
			SRCCOPY );
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
// 	case WM_CREATE:
// 		Splash_Close(hWnd);
// 		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

static void FreeRes()
{
	if( s_hBitmap )
	{
		DeleteObject(s_hBitmap);
		s_hBitmap = NULL;
	}
	if( s_hDCMemory )
	{
		DeleteDC(s_hDCMemory);
		s_hDCMemory = NULL;
	}
}